3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
21 wt_prefix=$(git rev-parse --show-prefix)
24 # Tell the rest of git that any URLs we get don't come
25 # directly from the user, so it can apply policy as appropriate.
26 GIT_PROTOCOL_FROM_USER=0
27 export GIT_PROTOCOL_FROM_USER
47 if test "$1" = "#unmatched"
54 # Print a submodule configuration setting
60 # Checks in the usual git-config places first (for overrides),
61 # otherwise it falls back on .gitmodules. This allows you to
62 # distribute project-wide defaults in .gitmodules, while still
63 # customizing individual repositories if necessary. If the option is
64 # not in .gitmodules either, print a default value.
66 get_submodule_config () {
70 value=$(git config submodule."$name"."$option")
73 value=$(git config -f .gitmodules submodule."$name"."$option")
75 printf '%s' "${value:-$default}"
80 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
83 # Sanitize the local git environment for use within a submodule. We
84 # can't simply use clear_local_git_env since we want to preserve some
85 # of the settings from GIT_CONFIG_PARAMETERS.
86 sanitize_submodule_env()
88 save_config=$GIT_CONFIG_PARAMETERS
90 GIT_CONFIG_PARAMETERS=$save_config
91 export GIT_CONFIG_PARAMETERS
95 # Add a new submodule to the working tree, .gitmodules and the index
99 # optional branch is stored in global branch variable
103 # parse $args after "submodule ... add".
109 case "$2" in '') usage ;; esac
120 case "$2" in '') usage ;; esac
125 reference_path="${1#--reference=}"
128 case "$2" in '') usage ;; esac
133 case "$2" in '') usage ;; esac
154 if test -n "$reference_path"
156 is_absolute_path "$reference_path" ||
157 reference_path="$wt_prefix$reference_path"
159 reference="--reference=$reference_path"
165 if test -z "$sm_path"; then
166 sm_path=$(printf '%s\n' "$repo" |
167 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
170 if test -z "$repo" || test -z "$sm_path"; then
174 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
176 # assure repo is absolute or relative to parent
179 test -z "$wt_prefix" ||
180 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
182 # dereference source url relative to parent's url
183 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
190 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
195 # multiple //; leading ./; /./; /../; trailing /
196 sm_path=$(printf '%s/\n' "$sm_path" |
206 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
207 die "$(eval_gettext "'\$sm_path' already exists in the index")"
209 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
211 eval_gettextln "The following path is ignored by one of your .gitignore files:
213 Use -f if you really want to add it." >&2
217 if test -n "$custom_name"
219 sm_name="$custom_name"
224 # perhaps the path exists and is already a git repo, else clone it
225 if test -e "$sm_path"
227 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
229 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
231 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
235 if test -d ".git/modules/$sm_name"
239 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
240 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
241 die "$(eval_gettextln "\
242 If you want to reuse this local git directory instead of cloning again from
244 use the '--force' option. If the local git directory is not the correct repo
245 or you are unsure what this means choose another name with the '--name' option.")"
247 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
250 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
252 sanitize_submodule_env
254 # ash fails to wordsplit ${branch:+-b "$branch"...}
256 '') git checkout -f -q ;;
257 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
259 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
261 git config submodule."$sm_name".url "$realrepo"
263 git add $force "$sm_path" ||
264 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
266 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
267 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
270 git config -f .gitmodules submodule."$sm_name".branch "$branch"
272 git add --force .gitmodules ||
273 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
277 # Execute an arbitrary command sequence in each checked out
280 # $@ = command to execute
284 # parse $args after "submodule ... foreach".
306 # dup stdin so that it can be restored when running the external
307 # command in the subshell (and a recursive call to this function)
311 git submodule--helper list --prefix "$wt_prefix" ||
314 while read mode sha1 stage sm_path
316 die_if_unmatched "$mode" "$sha1"
317 if test -e "$sm_path"/.git
319 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
320 say "$(eval_gettext "Entering '\$displaypath'")"
321 name=$(git submodule--helper name "$sm_path")
323 prefix="$prefix$sm_path/"
324 sanitize_submodule_env
326 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
327 # we make $path available to scripts ...
335 if test -n "$recursive"
337 cmd_foreach "--recursive" "$@"
340 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
346 # Register submodules in .git/config
348 # $@ = requested paths (default to all)
352 # parse $args after "submodule ... init".
373 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
377 # Unregister submodules from .git/config and remove their work tree
381 # parse $args after "submodule ... deinit".
409 if test -n "$deinit_all" && test "$#" -ne 0
411 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
414 if test $# = 0 && test -z "$deinit_all"
416 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
420 git submodule--helper list --prefix "$wt_prefix" "$@" ||
423 while read mode sha1 stage sm_path
425 die_if_unmatched "$mode" "$sha1"
426 name=$(git submodule--helper name "$sm_path") || exit
428 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
430 # Remove the submodule work tree (unless the user already did it)
431 if test -d "$sm_path"
433 # Protect submodules containing a .git directory
434 if test -d "$sm_path/.git"
436 die "$(eval_gettext "\
437 Submodule work tree '\$displaypath' contains a .git directory
438 (use 'rm -rf' if you really want to remove it including all of its history)")"
443 git rm -qn "$sm_path" ||
444 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
447 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
448 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
451 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
453 # Remove the .git/config entries (unless the user already did it)
454 if test -n "$(git config --get-regexp submodule."$name\.")"
456 # Remove the whole section so we have a clean state when
457 # the user later decides to init this submodule again
458 url=$(git config submodule."$name".url)
459 git config --remove-section submodule."$name" 2>/dev/null &&
460 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
465 is_tip_reachable () (
466 sanitize_submodule_env &&
468 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
472 fetch_in_submodule () (
473 sanitize_submodule_env &&
480 git fetch $(get_default_remote) "$@" ;;
485 # Update each submodule path to correct revision, using clone and checkout as needed
487 # $@ = requested paths (default to all)
491 # parse $args after "submodule ... update".
499 progress="--progress"
517 case "$2" in '') usage ;; esac
518 reference="--reference=$2"
534 recommend_shallow="--recommend-shallow"
536 --no-recommend-shallow)
537 recommend_shallow="--no-recommend-shallow"
540 case "$2" in '') usage ;; esac
548 case "$2" in '') usage ;; esac
571 cmd_init "--" "$@" || return
575 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
576 ${progress:+"$progress"} \
577 ${wt_prefix:+--prefix "$wt_prefix"} \
578 ${prefix:+--recursive-prefix "$prefix"} \
579 ${update:+--update "$update"} \
580 ${reference:+"$reference"} \
581 ${depth:+--depth "$depth"} \
582 ${recommend_shallow:+"$recommend_shallow"} \
584 "$@" || echo "#unmatched" $?
587 while read mode sha1 stage just_cloned sm_path
589 die_if_unmatched "$mode" "$sha1"
591 name=$(git submodule--helper name "$sm_path") || exit
592 url=$(git config submodule."$name".url)
593 if ! test -z "$update"
595 update_module=$update
597 update_module=$(git config submodule."$name".update)
598 if test -z "$update_module"
600 update_module="checkout"
604 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
606 if test $just_cloned -eq 1
609 update_module=checkout
611 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
612 git rev-parse --verify HEAD) ||
613 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
618 branch=$(git submodule--helper remote-branch "$sm_path")
619 if test -z "$nofetch"
621 # Fetch remote before determining tracking $sha1
622 fetch_in_submodule "$sm_path" $depth ||
623 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
625 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
626 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
627 git rev-parse --verify "${remote_name}/${branch}") ||
628 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
631 if test "$subsha1" != "$sha1" || test -n "$force"
634 # If we don't already have a -f flag and the submodule has never been checked out
635 if test -z "$subsha1" && test -z "$force"
640 if test -z "$nofetch"
642 # Run fetch only if $sha1 isn't present or it
643 # is not reachable from a ref.
644 is_tip_reachable "$sm_path" "$sha1" ||
645 fetch_in_submodule "$sm_path" $depth ||
646 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
648 # Now we tried the usual fetch, but $sha1 may
649 # not be reachable from any of the refs
650 is_tip_reachable "$sm_path" "$sha1" ||
651 fetch_in_submodule "$sm_path" $depth "$sha1" ||
652 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
656 case "$update_module" in
658 command="git checkout $subforce -q"
659 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
660 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
664 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
665 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
666 must_die_on_failure=yes
670 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
671 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
672 must_die_on_failure=yes
675 command="${update_module#!}"
676 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
677 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
678 must_die_on_failure=yes
681 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
684 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
687 elif test -n "$must_die_on_failure"
689 die_with_status 2 "$die_msg"
691 err="${err};$die_msg"
696 if test -n "$recursive"
699 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
701 sanitize_submodule_env
708 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
711 err="${err};$die_msg"
714 die_with_status $res "$die_msg"
739 sanitize_submodule_env
741 git describe "$2" 2>/dev/null ||
742 git describe --tags "$2" 2>/dev/null ||
743 git describe --contains "$2" 2>/dev/null ||
744 git describe --all --always "$2"
747 test -z "$revname" || revname=" ($revname)"
750 # Show commit summary for submodules in index or working tree
752 # If '--cached' is given, show summary between index and given commit,
753 # or between working tree and given commit
755 # $@ = [commit (default 'HEAD'),] requested paths (default all)
762 # parse $args after "submodule ... summary".
777 isnumber "$summary_limit" || usage
781 summary_limit="${1#--summary-limit=}"
782 isnumber "$summary_limit" || usage
798 test $summary_limit = 0 && return
800 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
804 elif test -z "$1" || test "$1" = "HEAD"
806 # before the first commit: compare with an empty tree
807 head=$(git hash-object -w -t tree --stdin </dev/null)
808 test -z "$1" || shift
816 die "$(gettext "The --cached option cannot be used with the --files option")"
822 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
823 # Get modified modules cared by user
824 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
825 sane_egrep '^:([0-7]* )?160000' |
826 while read mod_src mod_dst sha1_src sha1_dst status sm_path
828 # Always show modules deleted or type-changed (blob<->module)
829 if test "$status" = D || test "$status" = T
831 printf '%s\n' "$sm_path"
834 # Respect the ignore setting for --for-status.
835 if test -n "$for_status"
837 name=$(git submodule--helper name "$sm_path")
838 ignore_config=$(get_submodule_config "$name" ignore none)
839 test $status != A && test $ignore_config = all && continue
841 # Also show added or modified modules which are checked out
842 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
843 printf '%s\n' "$sm_path"
847 test -z "$modules" && return
849 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
850 sane_egrep '^:([0-7]* )?160000' |
852 while read mod_src mod_dst sha1_src sha1_dst status name
854 if test -z "$cached" &&
855 test $sha1_dst = 0000000000000000000000000000000000000000
859 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
861 100644 | 100755 | 120000)
862 sha1_dst=$(git hash-object $name)
868 eval_gettextln "unexpected mode \$mod_dst" >&2
875 test $mod_src = 160000 &&
876 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
879 test $mod_dst = 160000 &&
880 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
883 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
886 case "$missing_src,$missing_dst" in
888 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
891 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
894 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
899 if test $mod_src = 160000 && test $mod_dst = 160000
901 range="$sha1_src...$sha1_dst"
902 elif test $mod_src = 160000
908 GIT_DIR="$name/.git" \
909 git rev-list --first-parent $range -- | wc -l
911 total_commits=" ($(($total_commits + 0)))"
915 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
916 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
919 blob="$(gettext "blob")"
920 submodule="$(gettext "submodule")"
921 if test $mod_dst = 160000
923 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
925 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
928 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
932 # Don't give error msg for modification whose dst is not submodule
933 # i.e. deleted or changed to blob
934 test $mod_dst = 160000 && echo "$errmsg"
936 if test $mod_src = 160000 && test $mod_dst = 160000
939 test $summary_limit -gt 0 && limit="-$summary_limit"
940 GIT_DIR="$name/.git" \
941 git log $limit --pretty='format: %m %s' \
942 --first-parent $sha1_src...$sha1_dst
943 elif test $mod_dst = 160000
945 GIT_DIR="$name/.git" \
946 git log --pretty='format: > %s' -1 $sha1_dst
948 GIT_DIR="$name/.git" \
949 git log --pretty='format: < %s' -1 $sha1_src
957 # List all submodules, prefixed with:
958 # - submodule not initialized
959 # + different revision checked out
961 # If --cached was specified the revision in the index will be printed
962 # instead of the currently checked out revision.
964 # $@ = requested paths (default to all)
968 # parse $args after "submodule ... status".
996 git submodule--helper list --prefix "$wt_prefix" "$@" ||
999 while read mode sha1 stage sm_path
1001 die_if_unmatched "$mode" "$sha1"
1002 name=$(git submodule--helper name "$sm_path") || exit
1003 url=$(git config submodule."$name".url)
1004 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1005 if test "$stage" = U
1007 say "U$sha1 $displaypath"
1010 if test -z "$url" ||
1012 ! test -d "$sm_path"/.git &&
1013 ! test -f "$sm_path"/.git
1016 say "-$sha1 $displaypath"
1019 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1021 set_name_rev "$sm_path" "$sha1"
1022 say " $sha1 $displaypath$revname"
1024 if test -z "$cached"
1026 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1028 set_name_rev "$sm_path" "$sha1"
1029 say "+$sha1 $displaypath$revname"
1032 if test -n "$recursive"
1035 prefix="$displaypath/"
1036 sanitize_submodule_env
1041 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1046 # Sync remote urls for submodules
1047 # This makes the value for remote.$remote.url match the value
1048 # specified in .gitmodules.
1077 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1078 echo "#unmatched" $?
1080 while read mode sha1 stage sm_path
1082 die_if_unmatched "$mode" "$sha1"
1083 name=$(git submodule--helper name "$sm_path")
1084 url=$(git config -f .gitmodules --get submodule."$name".url)
1086 # Possibly a url relative to parent
1089 # rewrite foo/bar as ../.. to find path from
1090 # submodule work tree to superproject work tree
1091 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1092 # guarantee a trailing /
1093 up_path=${up_path%/}/ &&
1094 # path from submodule work tree to submodule origin repo
1095 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1096 # path from superproject work tree to submodule origin repo
1097 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1100 sub_origin_url="$url"
1101 super_config_url="$url"
1105 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1107 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1108 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1109 git config submodule."$name".url "$super_config_url"
1111 if test -e "$sm_path"/.git
1114 sanitize_submodule_env
1116 remote=$(get_default_remote)
1117 git config remote."$remote".url "$sub_origin_url"
1119 if test -n "$recursive"
1121 prefix="$prefix$sm_path/"
1132 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1135 # This loop parses the command line arguments to find the
1136 # subcommand name to dispatch. Parsing of the subcommand specific
1137 # options are primarily done by the subcommand implementations.
1138 # Subcommand specific options such as --branch and --cached are
1139 # parsed here as well, for backward compatibility.
1141 while test $# != 0 && test -z "$command"
1144 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1174 # No command word defaults to "status"
1175 if test -z "$command"
1185 # "-b branch" is accepted only by "add"
1186 if test -n "$branch" && test "$command" != add
1191 # "--cached" is accepted only by "status" and "summary"
1192 if test -n "$cached" && test "$command" != status && test "$command" != summary